; Same as pre-emptive.asm, but uses DMC interrupt for finer
; thread switching granularity (4142 times per second).

      .include "shell.asm"
      .include "threading.asm"
main:
      ; setup dmc interrupt
      lda   #$00
      sta   $4015
      lda   #$40
      sta   $4017
      bit   $4015
      lda   #$8F        ; maximum dmc rate
      sta   $4010
      lda   #$80        ; start = $E000
      sta   $4012
      lda   #0          ; one byte dmc sample
      sta   $4013
      cli
      
      ; Fork second thread
      jsr   fork
      bcs   thread2
      
      ; start thread-switching interrupt
      lda   #$10
      sta   $4015
      
; Both these loops run simultaneously
thread:
      ldy   #150        ; delay
dly:  dey
      nop
      nop
      bne   dly
      inc   sprite0_x   ; move sprite
      jmp   thread
      
thread2:
      ldy   #255        ; delay longer
dly2: dey
      nop
      nop
      bne   dly2
      inc   sprite1_x   ; move sprite
      jmp   thread2
      
; Change thread interrupt occurs periodically
irq:  pha               ; restart dmc timer
      lda   #$10
      sta   $4015
      pla
      jsr   yield       ; switch threads
      rti
      
