; Shell for demos. Sets up graphics and NMI, then
; jumps to main.

      ; iNES header
      .inesprg 1
      .ineschr 0
      .inesmap 0
      .inesmir 0
      
      ; vectors
      .bank 1
      .org  $FFFA
      .dw   nmi
      .dw   reset
      .dw   irq
      
      ; variables
      .zp
nmi_count:
      .ds 1
sprites = $700
sprite0_x = sprites + 3
sprite1_x = sprites + 7
      .code
      
      ; code
      .bank 1
      .org $E000  ; my devcart requires this addr
      
      .db   0     ; one-byte DMC sample
      
reset:
      ; init basics
      sei
      ldx   #$FF
      txs
      inx
      stx   $2000
      stx   $2001
      jsr   wait_vbl
      jsr   wait_vbl
      
      ; restore devcart's reset vector
      lda   #$FF
      sta   $FFFD
      lda   #$04
      sta   $FFFC
      
      ; clear zero page
      ldy   #0
      tya
zplp: sta   0,y
      iny
      bne   zplp
      
      ; set tile 0 to filled
      lda   #0
      sta   $2006
      sta   $2006
      ldy   #16
      lda   #$FF
tlp:  sta   $2007
      dey
      bne   tlp
      
      ; init sprites
      lda   #$FF
      ldy   #0
spil: sta   sprites,y
      iny
      bne   spil
      
      ; setup sprites 0 and 1
      lda   #32
      sta   sprites+0
      lda   #48
      sta   sprites+4
      lda   #0
      sta   sprites+1
      sta   sprites+5
      sta   sprites+2
      sta   sprites+6

      jsr   wait_vbl
      
      ; init palette
      lda   #$3F
      sta   $2006
      lda   #$10
      sta   $2006
      lda   #$0F
      sta   $2007
      lda   #$30
      sta   $2007
      sta   $2007
      sta   $2007
      
      ; enable sprites
      lda   #0
      sta   $2006
      sta   $2006
      sta   $2005
      sta   $2005
      lda   #$10
      sta   $2001
      
      ; enable nmi that updates sprites
      lda   #$80
      sta   $2000
      
      jmp   main

wait_vbl:
      bit   $2002
wvbl: bit   $2002
      bpl   wvbl
      rts

; Initiate sprite DMA every frame
nmi:  pha
      lda   #HIGH( sprites )
      sta   $4014
      pla
      rti

